%define anolis_release 2
%define debug_package %{nil}
%global kernel 5.10.134-16.an8
%global pkg udma
%global pkg_version 0.1.0

Name:       kmod-%{pkg}
Version:    %(echo %{kernel} | sed -E 's/-/~/g; s/\.(an|al)[0-9]+$//g')
Release:    %{pkg_version}~%{anolis_release}%{?dist}
Summary:    Driver for UDMA
License:    GPLv2
URL:        https://gitee.com/src-anolis-sig/%{name}

Source0:    %{name}-%{pkg_version}.tar.gz

Requires:            kernel >= %{kernel}
Requires(posttrans): %{_sbindir}/depmod
Requires(postun):    %{_sbindir}/depmod
Requires(posttrans): %{_sbindir}/weak-modules
Requires(postun):    %{_sbindir}/weak-modules
Requires(posttrans): %{_bindir}/sort
Requires(postun):    %{_bindir}/sort

BuildRequires:      gcc gcc-c++ make
Provides:           kmod-udma = %{release}
Obsoletes:          kmod-udma < %{release}
Obsoletes:          kmod-udma < %{pkg_version}.%{anolis_release}%{?dist}
ExclusiveArch:      x86_64

%description
kmod-udma is responsible for pin DMA memory for userspace.
It is the kernel driver for UDMA.

%prep
%autosetup -n %{name}-%{pkg_version}

%build

%install
KERNEL_VER=%{kernel}.%{_arch}
rm -rf %{buildroot}
mkdir -p %{buildroot}/lib/modules/${KERNEL_VER}/kernel
mkdir -p %{buildroot}/lib/modules/${KERNEL_VER}/extra

/usr/bin/install -D -m 750 %{_builddir}/%{name}-%{pkg_version}/%{_arch}/lib/modules/${KERNEL_VER}/kernel/udma_drv.ko %{buildroot}/lib/modules/${KERNEL_VER}/extra/

find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+

%{__install} -d %{buildroot}/%{_sysconfdir}/depmod.d/
for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
    echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done

%post
ECHO=/usr/bin/echo
${ECHO} "Creating module.dep file for UDMA"
depmod -a %{kernel}.%{_arch}
dracut -f /boot/initramfs-%{kernel}.%{_arch}.img %{kernel}.%{_arch}

if [ -x "/usr/sbin/weak-modules" ]; then
    printf '%s\n' "/lib/modules/%{kernel}.%{_arch}/extra/udma_drv.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
fi

%preun
echo "/lib/modules/%{kernel}.%{_arch}/extra/udma_drv.ko" >> /var/run/rpm-%{pkg}-modules.list

%postun
depmod -a %{kernel}.%{_arch}
dracut -f /boot/initramfs-%{kernel}.%{_arch}.img %{kernel}.%{_arch}

if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-%{pkg}-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules
fi

rm /var/run/rpm-%{pkg}-modules.list

%files
/lib/modules/%{kernel}.%{_arch}/extra/udma_drv.ko
%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}.conf

%changelog
* Fri Nov 24 2023 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.1.0-2
- Some typo fix

* Mon Nov 13 2023 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.1.0-1
- Change spec for oot weak module

* Mon Aug 21 2023 Xuchun Shang <xuchun.shang@linux.alibaba.com> - 0.1.0-1
- Init package
